/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelLocation } from '../model';
// @ts-ignore
import { LocationRequestBody } from '../model';
// @ts-ignore
import { PagedModelEntityModelLocation } from '../model';
/**
 * LocationEntityControllerApi - axios parameter creator
 * @export
 */
export const LocationEntityControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * delete-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceLocationDelete: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteItemResourceLocationDelete', 'id', id)
            const localVarPath = `/locations/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-location
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceLocationGet1: async (page?: number, size?: number, sort?: Array<string>, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/locations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceLocationGet: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getItemResourceLocationGet', 'id', id)
            const localVarPath = `/locations/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * patch-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceLocationPatch: async (id: string, locationRequestBody: LocationRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('patchItemResourceLocationPatch', 'id', id)
            // verify required parameter 'locationRequestBody' is not null or undefined
            assertParamExists('patchItemResourceLocationPatch', 'locationRequestBody', locationRequestBody)
            const localVarPath = `/locations/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(locationRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * create-location
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceLocationPost: async (locationRequestBody: LocationRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'locationRequestBody' is not null or undefined
            assertParamExists('postCollectionResourceLocationPost', 'locationRequestBody', locationRequestBody)
            const localVarPath = `/locations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(locationRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * update-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceLocationPut: async (id: string, locationRequestBody: LocationRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('putItemResourceLocationPut', 'id', id)
            // verify required parameter 'locationRequestBody' is not null or undefined
            assertParamExists('putItemResourceLocationPut', 'locationRequestBody', locationRequestBody)
            const localVarPath = `/locations/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(locationRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LocationEntityControllerApi - functional programming interface
 * @export
 */
export const LocationEntityControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = LocationEntityControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * delete-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteItemResourceLocationDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteItemResourceLocationDelete(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-location
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCollectionResourceLocationGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PagedModelEntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCollectionResourceLocationGet1(page, size, sort, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getItemResourceLocationGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getItemResourceLocationGet(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * patch-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async patchItemResourceLocationPatch(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.patchItemResourceLocationPatch(id, locationRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * create-location
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postCollectionResourceLocationPost(locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postCollectionResourceLocationPost(locationRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * update-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async putItemResourceLocationPut(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.putItemResourceLocationPut(id, locationRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * LocationEntityControllerApi - factory interface
 * @export
 */
export const LocationEntityControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = LocationEntityControllerApiFp(configuration)
    return {
        /**
         * delete-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceLocationDelete(id: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteItemResourceLocationDelete(id, options).then((request) => request(axios, basePath));
        },
        /**
         * get-location
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceLocationGet1(page?: number, size?: number, sort?: Array<string>, options?: any): AxiosPromise<PagedModelEntityModelLocation> {
            return localVarFp.getCollectionResourceLocationGet1(page, size, sort, options).then((request) => request(axios, basePath));
        },
        /**
         * get-location
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceLocationGet(id: string, options?: any): AxiosPromise<EntityModelLocation> {
            return localVarFp.getItemResourceLocationGet(id, options).then((request) => request(axios, basePath));
        },
        /**
         * patch-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceLocationPatch(id: string, locationRequestBody: LocationRequestBody, options?: any): AxiosPromise<EntityModelLocation> {
            return localVarFp.patchItemResourceLocationPatch(id, locationRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * create-location
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceLocationPost(locationRequestBody: LocationRequestBody, options?: any): AxiosPromise<EntityModelLocation> {
            return localVarFp.postCollectionResourceLocationPost(locationRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * update-location
         * @param {string} id 
         * @param {LocationRequestBody} locationRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceLocationPut(id: string, locationRequestBody: LocationRequestBody, options?: any): AxiosPromise<EntityModelLocation> {
            return localVarFp.putItemResourceLocationPut(id, locationRequestBody, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * LocationEntityControllerApi - interface
 * @export
 * @interface LocationEntityControllerApi
 */
export interface LocationEntityControllerApiInterface {
    /**
     * delete-location
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    deleteItemResourceLocationDelete(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;

    /**
     * get-location
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    getCollectionResourceLocationGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): AxiosPromise<PagedModelEntityModelLocation>;

    /**
     * get-location
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    getItemResourceLocationGet(id: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelLocation>;

    /**
     * patch-location
     * @param {string} id 
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    patchItemResourceLocationPatch(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelLocation>;

    /**
     * create-location
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    postCollectionResourceLocationPost(locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelLocation>;

    /**
     * update-location
     * @param {string} id 
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApiInterface
     */
    putItemResourceLocationPut(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelLocation>;

}

/**
 * LocationEntityControllerApi - object-oriented interface
 * @export
 * @class LocationEntityControllerApi
 * @extends {BaseAPI}
 */
export class LocationEntityControllerApi extends BaseAPI implements LocationEntityControllerApiInterface {
    /**
     * delete-location
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public deleteItemResourceLocationDelete(id: string, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).deleteItemResourceLocationDelete(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-location
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public getCollectionResourceLocationGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).getCollectionResourceLocationGet1(page, size, sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-location
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public getItemResourceLocationGet(id: string, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).getItemResourceLocationGet(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * patch-location
     * @param {string} id 
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public patchItemResourceLocationPatch(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).patchItemResourceLocationPatch(id, locationRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * create-location
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public postCollectionResourceLocationPost(locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).postCollectionResourceLocationPost(locationRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * update-location
     * @param {string} id 
     * @param {LocationRequestBody} locationRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationEntityControllerApi
     */
    public putItemResourceLocationPut(id: string, locationRequestBody: LocationRequestBody, options?: AxiosRequestConfig) {
        return LocationEntityControllerApiFp(this.configuration).putItemResourceLocationPut(id, locationRequestBody, options).then((request) => request(this.axios, this.basePath));
    }
}
